import uuid

from decimal import Decimal

from barker.schemas import to_camel
from pydantic import BaseModel, Field


class DiscountItem(BaseModel):
    id_: uuid.UUID
    name: str
    discount: Decimal | None = Field(ge=0, multiple_of=0.0001, default=0, le=1)
    limit: Decimal
    customer: Decimal

    class Config:
        alias_generator = to_camel
