import uuid

from pydantic import BaseModel, Field

from . import to_camel


class PrinterIn(BaseModel):
    name: str = Field(..., min_length=1)
    address: str = Field(..., min_length=1)
    cut_code: str

    class Config:
        anystr_strip_whitespace = True
        alias_generator = to_camel


class Printer(PrinterIn):
    id_: uuid.UUID

    class Config:
        anystr_strip_whitespace = True
        alias_generator = to_camel


class PrinterBlank(PrinterIn):
    name: str
    address: str

    class Config:
        anystr_strip_whitespace = True
        alias_generator = to_camel


class PrinterLink(BaseModel):
    id_: uuid.UUID = Field(...)

    class Config:
        fields = {"id_": "id"}
