from pydantic import BaseModel, Field

from . import to_camel


class RegimeIn(BaseModel):
    name: str = Field(..., min_length=1)
    header: str
    prefix: str = Field(..., min_length=1)
    is_fixture: bool

    class Config:
        alias_generator = to_camel


class Regime(RegimeIn):
    id_: int

    class Config:
        alias_generator = to_camel


class RegimeBlank(RegimeIn):
    name: str
    header: str
    prefix: str

    class Config:
        alias_generator = to_camel


class RegimeLink(BaseModel):
    id_: int = Field(...)
    name: str | None

    class Config:
        fields = {"id_": "id"}
