import { Component, Inject, OnInit } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { MAT_DIALOG_DATA, MatDialogRef } from '@angular/material/dialog';

import { MathService } from '../../shared/math.service';

@Component({
  selector: 'app-quantity',
  templateUrl: './quantity.component.html',
  styleUrls: ['./quantity.component.css'],
})
export class QuantityComponent implements OnInit {
  form: FormGroup<{
    quantity: FormControl<string>;
  }>;

  constructor(
    public dialogRef: MatDialogRef<QuantityComponent>,
    @Inject(MAT_DIALOG_DATA) public data: number,
    private math: MathService,
  ) {
    // Create form
    this.form = new FormGroup({
      quantity: new FormControl<string>('', { nonNullable: true }),
    });
  }

  ngOnInit() {
    this.form.setValue({
      quantity: `${this.data}`,
    });
  }

  accept(): void {
    const quantity = this.math.parseAmount(this.form.value.quantity ?? '');
    this.dialogRef.close(quantity);
  }
}
